package cz.cuni.attackbot;

import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Item;
import cz.cuni.amis.pogamut.ut2004.examples.attackbot.AttackBotContext;

/**
 * Action for walking randomly around the world and try to pick various items.
 *
 * @author Honza
 */
@PrimitiveInfo(name = "Pick items", description = "Go around the map and try to pick various items.")
public class PickItems extends StateAction<AttackBotContext> {

    private Item selectedItem = null;

    public PickItems(AttackBotContext ctx) {
        super(ctx);
    }

    @Override
    public void init(VariableContext params) {
        this.selectedItem = ctx.getItems().getRandomItem();
        ctx.getNavigation().navigate(selectedItem);
    }

    @Override
    public ActionResult run(VariableContext params) {
        if (ctx.getNavigation().isNavigating()) {
            return ActionResult.RUNNING;
        }
        return ActionResult.FINISHED;
    }

    @Override
    public void done(VariableContext params) {
        this.selectedItem = null;
        ctx.getNavigation().stopNavigation();
    }
}
